##############################################################################
#
# Copyright (c) 2001, 2002 Zope Corporation and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################
import zodb.storage.file
import zodb.storage.demo
import os
import tempfile
import unittest

from zodb.storage.tests import base, basic, conflict, corruption, history, \
     iterator, mt, packable, persistent, readonly, recovery, revision, \
     synchronization, undo, undoversion, version

class DemoStorageTests(base.StorageTestBase,
    basic.BasicStorage,
##    undo.TransactionalUndoStorage,
    revision.RevisionStorage,
    version.VersionStorage,
##    undoversion.TransactionalUndoVersionStorage,
##    packable.PackableStorage,
    synchronization.SynchronizedStorage,
##    conflict.ConflictResolvingStorage,
##    conflict.ConflictResolvingTransUndoStorage,
##    iterator.IteratorStorage,
##    iterator.ExtendedIteratorStorage,
##    persistent.PersistentStorage,
    mt.MTStorage,
##    readonly.ReadOnlyStorage,
                       ):
                       
    def setUp(self):
        self._base = zodb.storage.file.FileStorage(tempfile.mktemp())
        self._storage = zodb.storage.demo.DemoStorage(self._base)

    def tearDown(self):
        self._storage.close()
        self._base.close()
        self._base.cleanup()

    def checkDatabaseVersionPersistent(self):
        pass # XXX should this test be run?

    def checkPackVersions(self):
        pass # XXX this test should be run!

def test_suite():
    suite = unittest.makeSuite(DemoStorageTests, 'check')
    return suite
